package io.tswf.transmutations.staticview.exception

import groovy.transform.CompileStatic
import org.objectweb.asm.tree.ClassNode

@CompileStatic
class InvalidStaticViewClassException extends RuntimeException implements StaticViewClassReadingException.Bypass {
    ClassNode viewClass

    InvalidStaticViewClassException(String message, ClassNode viewClass) {
        super("The view class ${viewClass.javaName} is invalid: ${message}!")
        this.viewClass = viewClass
    }
}
