package io.tswf.transmutations.staticview.exception

import groovy.transform.CompileStatic
import io.tswf.transmutations.staticview.meta.StaticViewMethodMetadata

@CompileStatic
class InvalidStaticViewMethodException extends RuntimeException {
    StaticViewMethodMetadata viewMethodMeta

    InvalidStaticViewMethodException(String message, StaticViewMethodMetadata viewMethodMeta) {
        super("The static view method '${viewMethodMeta.viewMethod.javaFullName}' located in '${viewMethodMeta.view.viewClass.javaName}' is invalid: ${message}!")
        this.viewMethodMeta = viewMethodMeta
    }
}
