package io.tswf.transmutations.staticview.exception

import groovy.transform.CompileStatic
import io.tswf.transmutations.staticview.generation.IStaticViewMethodMapper
import io.tswf.transmutations.staticview.meta.StaticViewMethodMetadata

@CompileStatic
class MultipleStaticViewMethodMappersFoundException extends RuntimeException {
    StaticViewMethodMetadata viewMethodMeta
    List<IStaticViewMethodMapper> foundMappers

    MultipleStaticViewMethodMappersFoundException(StaticViewMethodMetadata viewMethodMeta, List<IStaticViewMethodMapper> foundMappers) {
        super("There is multiple view method mappers found for ${viewMethodMeta.viewMethod.javaFullName} in ${viewMethodMeta.view.viewClass.javaName}: ${foundMappers.map { it.class.name }}. Each method must have single mapper! Maybe you add multiple mapping annotations?")
        this.viewMethodMeta = viewMethodMeta
        this.foundMappers = foundMappers
    }
}
