package io.tswf.transmutations.staticview.exception

import groovy.transform.CompileStatic
import io.tswf.transmutations.staticview.meta.StaticViewMethodMetadata
import io.tswf.transmutations.staticview.reading.StaticViewMethodMetadataReader

@CompileStatic
class NoStaticViewMethodMapperFoundException extends RuntimeException {
    StaticViewMethodMetadata viewMethodMeta

    NoStaticViewMethodMapperFoundException(StaticViewMethodMetadata viewMethodMeta) {
        super("There is no method mapper found for ${viewMethodMeta.viewMethod.javaFullName} in ${viewMethodMeta.view.viewClass.javaName} in readers ${StaticViewMethodMetadataReader.methodMapperReaders}!")
        this.viewMethodMeta = viewMethodMeta
    }
}
