package io.tswf.transmutations.staticview.exception

import groovy.transform.CompileStatic
import io.tswf.transmutations.staticview.meta.StaticViewMetadata
import org.objectweb.asm.tree.ClassNode

@CompileStatic
class StaticViewInjectionException extends RuntimeException {
    StaticViewMetadata viewMeta
    ClassNode targetClass

    StaticViewInjectionException(Throwable cause, StaticViewMetadata viewMeta, ClassNode targetClass) {
        super("Exception occurred while trying to inject ${viewMeta.viewClass.javaName} view into ${targetClass.javaName} target:", cause)
        this.viewMeta = viewMeta
        this.targetClass = targetClass
    }
}
