package io.tswf.transmutations.staticview.exception

import groovy.transform.CompileStatic
import io.tswf.transmutations.staticview.meta.StaticViewMetadata
import io.tswf.transmutations.staticview.meta.StaticViewMethodMetadata
import org.objectweb.asm.tree.ClassNode

@CompileStatic
class StaticViewMethodInjectionException extends RuntimeException {
    StaticViewMethodMetadata viewMethodMeta
    ClassNode targetClass

    StaticViewMethodInjectionException(Throwable cause, StaticViewMethodMetadata viewMethodMeta, ClassNode targetClass) {
        super("Exception occurred while trying to inject ${viewMethodMeta.viewMethod.javaFullName} view method located in ${viewMethodMeta.view.viewClass.javaName} into ${targetClass.javaName} target:", cause)
        this.viewMethodMeta = viewMethodMeta
        this.targetClass = targetClass
    }
}
