package io.tswf.transmutations.staticview.reading

import groovy.transform.CompileStatic
import io.tswf.transmutations.staticview.generation.IStaticViewMethodMapper
import io.tswf.transmutations.staticview.meta.StaticViewMethodMetadata
import io.tswf.groovy.bettergroovy.transforms.validation.checkedmapconstructor.CheckedMapConstructor
import org.objectweb.asm.tree.MethodNode

interface IStaticViewMethodMapperReader {
    void handleStaticViewMethodReading(StaticViewMethodMapperReadingContext context)
}

@CompileStatic
@CheckedMapConstructor
class StaticViewMethodMapperReadingContext {
    StaticViewMethodMetadata viewMethodMeta

    MethodNode getTargetMethod() { viewMethodMeta.viewMethod }

    List<IStaticViewMethodMapper> result = new ArrayList<>()
}