package io.tswf.transmutations.staticview.reading.exclude

import groovy.transform.CompileStatic
import io.tswf.transmutations.staticview.meta.StaticViewMetadata
import org.objectweb.asm.tree.MethodNode

@CompileStatic
class ViewMethodMetadataExclusions {

    @Lazy
    static List<IStaticViewMethodMetadataExclusionFilter> exclusionFilters = ServiceLoader.load(IStaticViewMethodMetadataExclusionFilter)
        .toList()

    static boolean isNeedsToExcludeMethod(StaticViewMetadata viewMeta, MethodNode methodNode) {
        return exclusionFilters.any { it.isNeedsToExcludeMethod(viewMeta, methodNode) }
    }

}
