package io.tswf.transmutations.staticview.reading.exclude.filters

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.transmutations.staticview.meta.StaticViewMetadata
import io.tswf.transmutations.staticview.reading.exclude.IStaticViewMethodMetadataExclusionFilter
import org.objectweb.asm.tree.MethodNode

@AutoService(IStaticViewMethodMetadataExclusionFilter)
@CompileStatic
class GroovyInternalStaticViewMethodMetadataExclusionFilter implements IStaticViewMethodMetadataExclusionFilter {

    @Override
    boolean isNeedsToExcludeMethod(StaticViewMetadata viewMeta, MethodNode method) {
        return method.isMemberGroovyInternal(viewMeta.viewClass)
    }
}
