package io.tswf.transmutations.staticview.util

import groovy.transform.CompileStatic
import org.objectweb.asm.Type

@CompileStatic
class TypeMatchingUtil {

    static final Type OBJECT_TYPE = Object.asAsmType()

    static boolean areTypesMismatching(Type typeCanBeObject, Type typeCanNotBeObject) {
        return !areTypesMatching(typeCanBeObject, typeCanNotBeObject)
    }

    static boolean areTypesMatching(Type typeCanBeObject, Type typeCanNotBeObject) {
        if (typeCanBeObject == typeCanNotBeObject) {
            return true
        }

        if (typeCanBeObject == OBJECT_TYPE && !typeCanNotBeObject.isPrimitive()) {
            return true
        }

        return false
    }

}
